

#include "sfr_r82b.h"
#include "main_define.h"
#include "disp_definel.h"


//#pragma SECTION program pro_3

unsigned char rinse_led;
unsigned char display_number;

unsigned char left_time;

void soak_1(void);
void soak_2(void);
void soak_3(void);

/********************************************************************************

Inlet has 3 kinds of condition:

1, Normal;
2, During running;
3, Cycle ON/OFF;
4, Softener inlet: A, the inlet time value in time table is set higher than 2m
                   B, need take care if softener inlet are not 
				      finished while inlet already finished

*********************************************************************************/

void inlet(unsigned char inlet_time, unsigned char cycle, unsigned char level)
{
  static unsigned char cycle_buff = 0;
  unsigned char i;
  signed char j;
  
  if (process_left_time == 0)  		  /* ʣʱΪ0ʱùʣʱ */
  process_left_time = inlet_2m_buff;  
  
  if ((level)&&(inlet_time))	 /* ݵˮλͽˮʱΪʱˮ */
   {
	 if (water_full_flag != 1)
	  {
//     	Inlet_OPT = 0;
//	 	Inlet_OPT_1 = 0;
		output_buff |= INLET;	  /* 򿪽ˮ */
	  }
	  
	 j =  inlet_time;
	 
	 if (j > INLET_SET_TIME)	  /* ݱˮʱĬʱʱһˮƯϴ */
	  {
		if (softener_flag != 1);  			 /* жˮ */
		 {
//			SOF_Inlet_OPT = 0;
//			SOF_Inlet_OPT_1 = 0;
			output_buff |= SOFNER;
		 }
		if (inlet_10s_buff <= 0)
		 {
//	       SOF_Inlet_OPT = 1;
//		   SOF_Inlet_OPT_1 = 1;
		   output_buff &= (~SOFNER); 		 /* رˮ */
		   
		   inlet_10s_buff = SOFTENER_INLET_TIME;
		   
		   softener_flag = 1;
	 	   if (water_full_flag == 1) 		 /* עˮһ */
		    {
				process_left_time = 0;
				operation_counter ++;
				pass_time_counter ++;
				return;
		    }
		 }
	  }	  
	  
	 if (inlet_10s_buff > 0) 		 /* ˮʱ */
     inlet_10s_buff --;
	 if (inlet_20m_buff > 0)                                  
     inlet_20m_buff --;
	 if (inlet_2m_buff > 0)
	  {
	 	 inlet_2m_buff --;
	 	 process_left_time --; 		 /* ʣʱʱ */
	  }
	 
     if (inlet_20m_buff == 0)		 /* ˮʱж */
      {           
//	   Inlet_OPT = 1;
//	   Inlet_OPT_1 = 1;
	   output_buff &= (~INLET);
	                       
       inlet_20m_buff = INLET_ERR_TIME;
	   inlet_2m_buff = INLET_SET_TIME;
	   inlet_10s_buff = SOFTENER_INLET_TIME;
	   process_left_time = inlet_2m_buff;
	   
       err_buff = INLET_OVTIME_ERR;   
	   return;
      }	 
	  
	 if (water_level_buff >= 4)	 		/* 趨ˮλ4ˮλĽˮ */
	  {
		if (water_buff >= 3)			/* ˮλ3ˮλֹͣ2mʱ */
	 	 {
//         inlet_20m_buff = INLET_ERR_TIME;     
//	       inlet_2m_buff = INLET_SET_TIME;

//           inlet_20m_buff = 0;     
	       inlet_2m_buff = 0;
		   
		   if (water_buff == water_level_buff)
		    {
			  water_full_flag = 1;
	          
//			  Inlet_OPT = 1;
//			  Inlet_OPT_1 = 1;
			  output_buff &= (~INLET);
			  
			  if ((j == INLET_SET_TIME)||(j == 40))		 /* ˮ */
			   {
           		   inlet_20m_buff = INLET_ERR_TIME;     
	       		   inlet_2m_buff = INLET_SET_TIME;	
				   	
				   process_left_time = 0;						
				   operation_counter ++;
				   pass_time_counter ++;
				   return;				   
			   }
		   	  else if ((j > INLET_SET_TIME)&&(softener_flag == 1))	 /* һνˮ */
		       {
           		   inlet_20m_buff = INLET_ERR_TIME;     
	       		   inlet_2m_buff = INLET_SET_TIME;	
				   
				   process_left_time = 0;						
				   operation_counter ++;
				   pass_time_counter ++;
				   return;
		       }
		    }			   
		 } 
	  }
     if (water_buff == water_level_buff)		 /* ˮλ趨С4ˮλʱĴ */
      {
//        inlet_20m_buff = INLET_ERR_TIME;     
//	    inlet_2m_buff = INLET_SET_TIME;

//        inlet_20m_buff = 0;     
	    inlet_2m_buff = 0;
		
//		Inlet_OPT = 1;
//		Inlet_OPT_1 = 1;
		output_buff &= (~INLET);

		water_full_flag = 1;
		
		if ((j == INLET_SET_TIME)||(j == 40))	 /* ˮ */
		 {
			 inlet_20m_buff = INLET_ERR_TIME;
			 inlet_2m_buff = INLET_SET_TIME;
			 
			 process_left_time = 0;			 
			 operation_counter ++; 
			 pass_time_counter ++;
			 return;
		 }
		else if ((j > INLET_SET_TIME)&&(softener_flag == 1))	 /* һνˮ */
		 {
			 inlet_20m_buff = INLET_ERR_TIME;
			 inlet_2m_buff = INLET_SET_TIME;
			 
			 process_left_time = 0;			 
			 operation_counter ++; 
			 pass_time_counter ++;
			 return;
		 }		
      }
	  
    return;
	
   }
  else if ((level)&&(!inlet_time)) 	/* ݲֻˮλΪʱвˮĽˮ */
   {
	 if (water_full_flag != 1)     
	  {
//    	Inlet_OPT = 0;
//	 	Inlet_OPT_1 = 0;	 
		output_buff |= INLET;
	  }        
	 
	 if (inlet_20m_buff > 0)                                           
     inlet_20m_buff --;
	 if (inlet_2m_buff > 0)
	  {
     	inlet_2m_buff --;
	 	process_left_time --;
	  }

     if (water_buff == water_level_buff)
      {
        inlet_20m_buff = INLET_ERR_TIME;     
	    inlet_2m_buff = INLET_SET_TIME;
		
//      Inlet_OPT = 1;
//	    Inlet_OPT_1 = 1;		
	 	output_buff &= (~INLET);
		
		water_full_flag = 1;
	    return;
      }
     else if (inlet_20m_buff <= 0)
     {
       err_buff = INLET_OVTIME_ERR;                                         
       inlet_20m_buff = INLET_ERR_TIME;
	   return;
     }
   }
  else if (cycle)			/* ݲֻѭΪʱвˮ̣δô */
   {
	 if (cycle_start_flag != 1)
	  {
		  cycle_buff = cycle;
		  cycle_start_flag = 1;
	  }
	  
	 i = cycle_buff;
	 i &= 0x80;
//	 cycle_buff = cycle_buff << 1;
	 
	 if (i != 0)
	  {
//     	  Inlet_OPT = 0;
//	 	  Inlet_OPT_1 = 0;	
		  output_buff |= INLET;
		    
		  if (inlet_2m_buff > 0)
		  inlet_2m_buff --;
		  
		  if ((INLET_SET_TIME - inlet_2m_buff) == 35)
			{
//     			Inlet_OPT = 1;
//	 			Inlet_OPT_1 = 1;	
				output_buff &= (~INLET);			
	 
				inlet_2m_buff = INLET_SET_TIME;
				cycle_buff = cycle_buff << 1;
				if (cycle_buff == 0)
				 {
//					 if ((program_buff == SPEEDY)||(program_buff == FASTEST))
					 mot_cycle_buff = MOT_STOP;
					 output_buff &= (~CW);
					 output_buff &= (~CCW);					 
				 }
				
//				operation_counter ++;
				pass_time_counter ++;

			}
	  }
	 else if (i == 0)
	  {
		  if (inlet_2m_buff > 0)
		  inlet_2m_buff --;
		  if ((INLET_SET_TIME - inlet_2m_buff) == 30)
			{
				inlet_2m_buff = INLET_SET_TIME;
				cycle_buff = cycle_buff << 1;
				
//				operation_counter ++;
				pass_time_counter ++;
				
				if (cycle_buff == 0)
				 {
/*				   if (program_buff == SPEEDY)
				    {
					 	cycle_start_flag = 0;
					 	operation_counter += 9;
					 	pass_time_counter ++;						
					}
				   if (program_buff == FASTEST)
				    {
					 	cycle_start_flag = 0;
					 	operation_counter += 5;
					 	pass_time_counter ++;						
					}
				   else if ((program_buff != SPEEDY)&&(program_buff != FASTEST))*/
				 	{
					 	mot_cycle_buff = MOT_STOP;
						output_buff &= (~CW);
						output_buff &= (~CCW);
					
						process_left_time = 0;		// here need check the process left time		
					 	cycle_start_flag = 0;
					 	operation_counter += 8;
					 	pass_time_counter ++;
				 	}
				 }
			}
	  }	  
	  
   }
  else 
  return;
}

/******************************************************************************************

void drain( void ): ˮ̴

******************************************************************************************/

void drain( void )
{          

//  Drain_OPT = 0;
//  Drain_OPT_1 = 0;
  output_buff |= DRAIN;					/* ˮʼ */
  
  if (drain_8m_buff > 0)
  drain_8m_buff --;						/* ˮ8mʱ */
  
  if (process_left_time == 0)			/* ùʣʱ */
  process_left_time = drain_2m_buff;
  
  if ((drain_2m_buff > 0)&&(drain_empty_flag == 0))
   {
  		drain_2m_buff --;				/* ˮʱʱ */
  		process_left_time --;
   }
  
  if (drain_2m_buff == 0)
   {
   }
  
  if (water_buff == 0)					/* ˮʱˮ */
   {
	if (drain_2m_buff < 119)
     {
	   if (drain_60s_buff > 0)
	    {
       		drain_60s_buff --;
			process_left_time = drain_60s_buff;
	    }
       if (drain_60s_buff == 0)
         {
            drain_60s_buff = DRAIN_CONT_TIME;
			drain_8m_buff = DRAIN_ERR_TIME;  
			drain_2m_buff = DRAIN_SET_TIME;
			
			process_left_time = 0;			
			operation_counter ++;
			pass_time_counter ++;
			save_water_once_flag = 0;
			
			return;           
         }
     }	 
	else if (drain_2m_buff == 119)			/* ʼˮʱˮλΪ0ˮ̴ */
     {
	   drain_empty_flag = 1;
	   if (drain_10s_buff > 0)
	    {
       		drain_10s_buff --;
//			process_left_time = drain_10s_buff;
	    }
	   if (drain_20s_buff > 0)
	    {
	   		drain_20s_buff --;
			process_left_time = drain_20s_buff;
	    }
	   
       if (drain_20s_buff == 0)
         {
            drain_10s_buff = DRAIN_CONT_TIME_A;
			drain_20s_buff = DRAIN_CONT_TIME_B;
			drain_8m_buff = DRAIN_ERR_TIME;  
			drain_2m_buff = DRAIN_SET_TIME;
			drain_empty_flag = 0;
			
			process_left_time = 0;			
			operation_counter ++;
			pass_time_counter ++;
			save_water_once_flag = 0;
			return;          
         }
       else if (drain_10s_buff == 0)
         {
			if (machine_type == MACHINE_A)
			 {
               drain_10s_buff = DRAIN_CONT_TIME_A;
			   drain_20s_buff = DRAIN_CONT_TIME_B;
			   drain_8m_buff = DRAIN_ERR_TIME;  
			   drain_2m_buff = DRAIN_SET_TIME;
			   drain_empty_flag = 0;
			   
			   process_left_time = 0;			
			   operation_counter ++;
			   pass_time_counter ++;
			   save_water_once_flag = 0;
			   return;     
			 }      
         }	 
		 
     }
   }

  else if (drain_8m_buff == 0)			/* ˮʱ */
  
   {
	  drain_8m_buff = DRAIN_ERR_TIME;  
	  drain_2m_buff = DRAIN_SET_TIME;
      drain_10s_buff = DRAIN_CONT_TIME_A;
	  drain_20s_buff = DRAIN_CONT_TIME_B;
      drain_60s_buff = DRAIN_CONT_TIME;
	  
	  process_left_time = drain_2m_buff;	   
      err_buff = DRAIN_ERR;  
	  return;
   }

  else
  return;
	   
}

/******************************************************************************************

void soak(unsigned int soak_time): ݹ̴

******************************************************************************************/

void soak(unsigned int soak_time)
{
  unsigned char i;
  
  if (water_full_flag == 0)
   {
	 i = water_level_buff - water_buff;  		/* жˮλ½Ƿ񳬹һ */
	 
	 if (i >= 1)					/* ˮλ½һʱвˮ */
	  {
	    status_buff = STOP;					
		run_inlet_flag = 1;
		if (water_buff != water_level_buff)	
		 {	
			inlet(0, 0, water_level_buff);	
			return;
		 }
	  }
   }
   
  if (lid_open)				/* ݿǣд */
   {
       err_buff = OPEN_LID_ERR;  				
       return;
   }

  if (soak_time == 10)		/* 10ӽϳ */
   {
	   if ((process_left_time == 0)&&(soak_2_cycle_buff != 1))
	   process_left_time = soak_time * 60;
	   
	   process_left_time --;  
	   
	   if (soak_1_cycle_buff != 1)
	   soak_1();			/* ִнݹ 1 */
	   
	   if ((soak_2_cycle_buff != 1)&&(soak_1_cycle_buff == 1))
	   soak_2();			/* ִнݹ 2 */
	   
	   else if (soak_2_cycle_buff == 1)
	    {
			pass_time_counter ++;
			operation_counter ++;
			process_left_time = 0;
	    }
		
	   return;
   }
  else if (soak_time == 20)		/* 20ӽϳ */
   {
	   if ((process_left_time == 0)&&(soak_3_cycle_buff != 1))
	   process_left_time = soak_time * 60;
	   
	   process_left_time --;  
	   	   
	   if (soak_1_cycle_buff != 1)
	   soak_1();			/* ִнݹ 1 */
	   
	   if ((soak_2_cycle_buff != 1)&&(soak_1_cycle_buff == 1))
	   soak_2();			/* ִнݹ 2 */
	   
	   if ((soak_3_cycle_buff != 1)&&(soak_2_cycle_buff == 1)&&(soak_1_cycle_buff == 1))
	   soak_3();			/* ִнݹ 3 */
	   
	   else if (soak_3_cycle_buff == 1)
	    {
			pass_time_counter ++;
			operation_counter ++;
			process_left_time = 0;
		}
	   return;
   }
  else if (soak_time == 30)		/* 30ӽϳ */
   {
	   if ((process_left_time == 0)&&(soak_3_cycle_buff != 2))
	   process_left_time = soak_time * 60;
	   
	   process_left_time --;  	   
	   
	   if (soak_1_cycle_buff != 1)
	   soak_1();			/* ִнݹ 1 */
	   
	   if ((soak_2_cycle_buff != 1)&&(soak_1_cycle_buff == 1))
	   soak_2();			/* ִнݹ 2 */
	   
	   if ((soak_3_cycle_buff != 2)&&(soak_2_cycle_buff == 1)&&(soak_1_cycle_buff == 1))
	   soak_3();			/* ִнݹ 3 */
	   
	   else if (soak_3_cycle_buff == 2)
	    {
			pass_time_counter ++;
			operation_counter ++;
			process_left_time = 0;
	    }
	   return;
   }
  else if (soak_time == 40)		/* 40ӽϳ */
   {
	   if ((process_left_time == 0)&&(soak_3_cycle_buff != 3))
	   process_left_time = soak_time * 60;
	   
	   process_left_time --;  	   
	   
	   if (soak_1_cycle_buff != 1)
	   soak_1();			/* ִнݹ 1 */
	   
	   if ((soak_2_cycle_buff != 1)&&(soak_1_cycle_buff == 1))
	   soak_2();			/* ִнݹ 2 */
	   
	   if ((soak_3_cycle_buff != 3)&&(soak_2_cycle_buff == 1)&&(soak_1_cycle_buff == 1))
	   soak_3();			/* ִнݹ 3 */
	   
	   else if (soak_3_cycle_buff == 3)
	    {
			pass_time_counter ++;
			operation_counter ++;
			process_left_time = 0;
	    }
	   return;	   
   }
  else
  return;
}

/******************************************************************************************

void wash(unsigned int wash_time): ϴӹ̴

******************************************************************************************/

void wash(unsigned int wash_time)
{
  unsigned char i;
  unsigned char j;
    	
if (water_full_flag == 0)
 {
	i = water_level_buff - water_buff;  	/* жϴˮλ½Ƿ񳬹һ */
	 
	if (i >= 1)								/* ˮλ½һʱвˮ */
	 {
	    status_buff = STOP;					
		run_inlet_flag = 1;
		if (water_buff != water_level_buff)	
		 {	
			inlet(0, 0, water_level_buff);
			return;
		 }
	 }
 }
   
if (lid_open)								/* ϴӿǣд */
 {
	err_buff = OPEN_LID_ERR;  				
	return;
 }

if (program_auto_flag == 1)
 {
	 ;
 }

//if (wash_finish_flag != 1)
// {
	if (wash_start_flag == 0)			/* ϴӹ̿ʼв */
 	 {
	 	wash_start_flag = 1;
	 	balance_time_buff = 30;
	 	run_stream_time = wash_time;
		process_left_time = wash_time + balance_time_buff;
 	 }

	if (wash_start_flag == 1)			/* ϴӹ */
 	 {
	 	if (run_stream_time > 0)
	  	 {
		   if ((program_buff >= 3)&&(program_buff <= 6)&&(water_level >= 1))
		    {			/* мǿˮʱдǿˮϴ */
			  if (main_stream_time > 0)
			   {
				  stream_buff = MAIN_STREAM;			/* õת */
				  main_stream_time --;
			   }
			  if (main_stream_time == 0)
			   {
				  if (ext_stream_time > 0)
				   {
					  stream_buff == EXT_STREAM;		/* ִмǿˮ */
					  ext_stream_time --;
				   }	  
				  if (ext_stream_time == 0)				/* ǿˮʱΪ0ϴӽ */
				   {
					  main_stream_time = 170;
					  ext_stream_time = 10; 
					  stream_buff = MAIN_STREAM;
				   }
			   }
			}
		   else 
		   stream_buff = MAIN_STREAM;		/* ǿˮˮѭ */
		   
		   run_stream_time --;
		   process_left_time --;
		   
	  	 }
	 	if (run_stream_time == 0)			/* ϴʱ30ƽˮϴӺͽ */
	  	 {
		 	stream_buff = BALANCE_STREAM;
		 
		 	if (balance_time_buff > 0)		/* 30ƽˮϴӺͽ */
			 {
		 		balance_time_buff --;
				process_left_time --;
			 }
		 
		 	if (balance_time_buff == 0)		/*  */
		  	 {
			  	balance_time_buff == 30;
				wash_start_flag = 0;
//			  	wash_finish_flag = 1;
				stream_buff = STREAM_STOP;
				
				mot_cycle_buff &= MOT_STOP;				
				output_buff &= (~CW);
				output_buff &= (~CCW);
				
				operation_counter += 2;
				pass_time_counter += 2;
				
				process_left_time = 0;
				return;
		  	 }
	  	 }
		return;
 	 }
// }
 return;
}

/******************************************************************************************

void interm_spin(unsigned int interm_spin_time): ˮ̴

******************************************************************************************/

void interm_spin(unsigned int interm_spin_time)
{
  static unsigned char interm_spin_cycle;
  
  if (process_left_time == 0)		/* ʣʱΪ0ʣʱ */
  process_left_time = interm_spin_time;
  
  if (lid_open)						/* ˮĽд */
   {
	   err_buff = OPEN_LID_ERR;  		
       return;
   }
  if (unbalance_flag == 1)		/* жǷвƽ */
   {
	   if (water_full_flag == 0)		/* ˮ */
	    {
			if (balance_inlet_flag == 0)
			 {				 
				 balance_inlet_flag = 1;
//				 inlet(0, 0, water_level_buff);
				 output_buff |= INLET;
				 inlet_2m_buff = INLET_SET_TIME;			 
			 }
			 
			if (inlet_2m_buff >= 0)
			inlet_2m_buff --;		 

			if (balance_stream_flag == 1)
			 {
				 balance_inlet_flag = 0;
				 balance_stream_flag = 0;
				 balance_drain_flag = 0;
				 inlet_2m_buff = INLET_SET_TIME;
				 drain_2m_buff = DRAIN_SET_TIME;
				 spin_balance_time_buff = 60;					  
				 unbalance_flag = 0;
			 }			 
			 
	    }
	   if (water_full_flag == 1)		/* ˮʱвƽƽˮϴӹ */
	    {
			if (balance_stream_flag == 0)
			 {
				balance_stream_flag = 1;
			 	output_buff &= (~INLET);
			 	stream_buff = BALANCE_STREAM;
			 	spin_balance_time_buff = 60;
			 }
			
			if (spin_balance_time_buff > 0)
			 {
				 spin_balance_time_buff --;
			 }
			if (spin_balance_time_buff == 0)
			 {
				 stream_buff = STREAM_STOP;
				 output_buff &= (~CW);
				 output_buff &= (~CCW);
				 
				 if (water_full_flag != 0)
				  {
					  if (balance_drain_flag == 0)
					   {
						   balance_drain_flag = 1;
						   drain_2m_buff = DRAIN_SET_TIME;
						   output_buff |= DRAIN;
//						   drain();
					   }
					   
					  if(drain_2m_buff >= 0)
					  drain_2m_buff --;
				  }

			 }
	    }
	   return;
   }

  else if (interm_spin_time == 135)		/* ˮʱΪ135sʱ910s/5s */
   {  
    if (interm_spin_10s_buff > 0)
	 {
		 mot_cycle_buff = MOT_RIGHT;
		 output_buff |= CW;
		 	
		 interm_spin_10s_buff --;
		 process_left_time --;
	 }
    if (interm_spin_10s_buff == 0)
     {
        mot_cycle_buff = MOT_STOP;
		output_buff &= (~CW);
		
	    if (interm_spin_5s_buff > 0)
		 {
	    	interm_spin_5s_buff --;
			process_left_time --;
		 }
	    if (interm_spin_5s_buff == 0)
	     {
		    interm_spin_10s_buff = 10;
		    interm_spin_5s_buff = 5;
				 
		    interm_spin_cycle ++;
		    if (interm_spin_cycle == 9)
		     {
			   interm_spin_cycle = 0;
			   
			   process_left_time = 0;			   
		       operation_counter ++;
			   pass_time_counter ++;
			   
			   mot_cycle_buff = MOT_RIGHT;
			   output_buff |= CW;
		       return;
		     }
	     }
        else
	    return;
     }
    else
    return;
   }
  else if (interm_spin_time != 135)	/* ˮʱ䲻Ϊ135sʱжӦ4s/3s */
   {  
    if (interm_spin_4s_buff > 0)
	 {
		 mot_cycle_buff = MOT_RIGHT;
		 output_buff |= CW;
		 
		 interm_spin_4s_buff --;
		 process_left_time --;
	 }
    if (interm_spin_4s_buff == 0)
     {
        mot_cycle_buff = MOT_STOP;
		output_buff &= (~CW);
		
	    if (interm_spin_3s_buff > 0)
		 {
			 process_left_time --;
	    	interm_spin_3s_buff --;
		 }
	    if (interm_spin_3s_buff == 0)
	     {
		    interm_spin_4s_buff = 4;
		    interm_spin_3s_buff = 3;
				 
		    interm_spin_cycle ++;
		    if (interm_spin_time == 20)			/* ˮʱΪ20sʱ34s/3s */
		     {
		       if (interm_spin_cycle == 3)
		        {
			      interm_spin_cycle = 0;
				  
				  process_left_time = 0;				  
				  pass_time_counter ++;
		          operation_counter ++;
				  
			      mot_cycle_buff = MOT_RIGHT;
				  output_buff |= CW;
				  				  
		          return;
		        }
		     }
		    else if (interm_spin_time == 30)	/* ˮʱΪ30sʱ44s/3s */
		     { 
		       if (interm_spin_cycle == 4)
		        {
			      interm_spin_cycle = 0;
				  
				  process_left_time = 0;
		          operation_counter ++;
				  pass_time_counter ++;
				  
			      mot_cycle_buff = MOT_RIGHT;
				  output_buff |= CW;
				  
		          return;
		        }
		     }
		    else if (interm_spin_time == 60)	/* ˮʱΪ60sʱ84s/3s */
		     {
		       if (interm_spin_cycle == 8)
		        {
			      interm_spin_cycle = 0;
				  
				  process_left_time = 0;				  
		          operation_counter ++;
				  pass_time_counter ++;
				  
			      mot_cycle_buff = MOT_RIGHT;
				  output_buff |= CW;
				  
		          return;
		        }
		     }
		    else if (interm_spin_time >= 255)	/* ˮʱ255sʱмˮʱ/74s/3s */
		     {
		       if (interm_spin_cycle == interm_spin_time/7)
		        {
			      interm_spin_cycle = 0;
				  
				  process_left_time = 0;				  
		          operation_counter ++;
				  pass_time_counter ++;
				  
			      mot_cycle_buff = MOT_RIGHT;
				  output_buff |= CW;
				  
		          return;
		        }
		     }			 
	     }
	    else
	    return;
     }
    else
    return;
   }
} 

/******************************************************************************************

spin(unsigned int spin_time): ˮ̴

******************************************************************************************/

void spin(unsigned int spin_time)
{
  static unsigned int spin_time_buff = 0;
  
  if (process_left_time == 0)			/* ʣʱΪ0ʣʱ */
  process_left_time = spin_time + 30 + 5;  
  
  if (lid_open)							/* ˮǣд */
   {
	   err_buff = OPEN_LID_ERR;  			// need check how to handle the ERR_PROCESS;
       return;
   }
  if (unbalance_flag == 1)				/* жǷвƽ */
   {
	   if (water_full_flag == 0)		/* ˮ */
	    {
			if (balance_inlet_flag == 0)
			 {				 
				 balance_inlet_flag = 1;
//				 inlet(0, 0, water_level_buff);
				 output_buff |= INLET;
				 inlet_2m_buff = INLET_SET_TIME;			 
			 }
			 
			if (inlet_2m_buff >= 0)
			inlet_2m_buff --;		 

			if (balance_stream_flag == 1)
			 {
				 balance_inlet_flag = 0;
				 balance_stream_flag = 0;
				 balance_drain_flag = 0;
				 inlet_2m_buff = INLET_SET_TIME;
				 drain_2m_buff = DRAIN_SET_TIME;
				 spin_balance_time_buff = 60;					  
				 unbalance_flag = 0;
			 }			 
			 
	    }
	   if (water_full_flag == 1)		/* ˮʱвƽƽˮϴӹ */
	    {
			if (balance_stream_flag == 0)
			 {
				balance_stream_flag = 1;
			 	output_buff &= (~INLET);
			 	stream_buff = BALANCE_STREAM;
			 	spin_balance_time_buff = 60;
			 }
			
			if (spin_balance_time_buff > 0)
			 {
				 spin_balance_time_buff --;
			 }
			if (spin_balance_time_buff == 0)
			 {
				 stream_buff = STREAM_STOP;
				 output_buff &= (~CW);
				 output_buff &= (~CCW);
				 
				 if (water_full_flag != 0)
				  {
					  if (balance_drain_flag == 0)
					   {
						   balance_drain_flag = 1;
						   drain_2m_buff = DRAIN_SET_TIME;
						   output_buff |= DRAIN;
//						   drain();
					   }
					   
					  if(drain_2m_buff >= 0)
					  drain_2m_buff --;
				  }
			 }
	    }
	   return;
   }
 
  if (spin_time_buff < spin_time)
   {
	   mot_cycle_buff = MOT_RIGHT;			/* ʼˮ */
	   output_buff |= CW;
	   
	   spin_time_buff ++;
	   process_left_time -- ;
   }
  if (spin_time_buff == spin_time)			/* ˮ */
   {
       mot_cycle_buff = MOT_STOP;
	   output_buff &= (~CW);
	   
	   if (inertial_30s_buff > 0)			/* 30s ˮ */
	    {
	   		inertial_30s_buff --;
       		process_left_time --;
	    }	   
	   if (inertial_30s_buff ==0)			/* ˮ */
	    {
//			if (program_buff != TUBE_DRY)
//	        output_buff &= (~DRAIN);
			
//			else if ((program_buff == TUBE_DRY)&&(operation_counter >=5))
//			output_buff &= (~DRAIN);
			
	   		if (break_5s_buff > 0)			/* 5s ɲ */
			 {
//				 Drain_OPT = 1;
//				 Drain_OPT_1 = 1;
				 output_buff &= (~DRAIN);
				 
				 break_5s_buff --;	
				 process_left_time --;		 
			 }
		
			if (break_5s_buff == 0)			/* ˮ */
			 {
				spin_time_buff = 0;
				inertial_30s_buff = 30;
				break_5s_buff = 5;
				
				process_left_time = 0;
				operation_counter += 3;
				pass_time_counter += 3;
			 }
		}
		 
   }
  return;
}

/***********************************************************************************************

void soak_x(void): ݹx

***********************************************************************************************/


void soak_1(void)				/* ݹ1Ϊ2m/3m */
{
  stream_buff = MAIN_STREAM;
		 
  if (soak_2m_buff > 0)			/* 2mУת */
  soak_2m_buff --;
		 
  if (soak_2m_buff == 0)		/* 2m */
   {
	 stream_buff = STREAM_STOP;
	 mot_cycle_buff &= MOT_STOP;
	 output_buff &= (~CW);
	 output_buff &= (~CCW);
	 
	 if (soak_3m_buff > 0)		/* ֹͣ3 */
	 soak_3m_buff --;
			  
	 if (soak_3m_buff == 0)		/* 3mʱ䵽ѭ1 */
	  {
		soak_2m_buff = 120;
		soak_3m_buff = 180;
				   
		soak_1_cycle_buff ++;	   
	  }
  }
}

void soak_2(void)					/* ݹ1Ϊ1m/4m */
{
  stream_buff = MAIN_STREAM;
		 
  if (soak_1m_buff > 0)				/* 1mУת */
  soak_1m_buff --;
		 
  if (soak_1m_buff == 0)			/* 1m */
   {
	 stream_buff = STREAM_STOP;
	 mot_cycle_buff &= MOT_STOP;
	 output_buff &= (~CW);
	 output_buff &= (~CCW);	 
	 
	 if (soak_4m_buff > 0)			/* ֹͣ4 */
	 soak_4m_buff --;
			  
	 if (soak_4m_buff == 0)			/* 4mʱ䵽ѭ1 */
	  {
		soak_1m_buff = 60;
		soak_4m_buff = 240;
				   
		soak_2_cycle_buff ++;	   
	  }
  }
}

void soak_3(void)					/* ݹ1Ϊ1m/9m */
{
  stream_buff = MAIN_STREAM;
		 
  if (soak_1m_buff > 0)				/* 1mУת */
  soak_1m_buff --;
		 
  if (soak_1m_buff == 0)			/* 1m */
   {
	 stream_buff = STREAM_STOP;
	 mot_cycle_buff &= MOT_STOP;
	 output_buff &= (~CW);
	 output_buff &= (~CCW);	 
	 
	 if (soak_9m_buff > 0)			/* ֹͣ9 */
	 soak_9m_buff --;
			  
	 if (soak_9m_buff == 0)			/* 9mʱ䵽ѭ1 */
	  {
		soak_1m_buff = 60;
		soak_9m_buff = 540;
				   
		soak_3_cycle_buff ++;	   
	  }
  }
}

/***********************************************************************************************

void run_stream(void): ˮд

***********************************************************************************************/

void run_stream(void)		/* ó߼ˮѡˮѡתв */
{
  static unsigned int run_time = 600;
  static unsigned int stop_time = 800;
	
  if (stream_buff == MAIN_STREAM)
   {
/*	   if (program_buff == SPEEDY)
	    {
			if (operation_counter == 1)
			 {
				 run_time = Speedy_Stream_A[0].run;
				 stop_time = Speedy_Stream_A[0].stop;
			 }
			if (operation_counter == 3)
			 {
				 run_time = Speedy_Stream_A[1].run;
				 stop_time = Speedy_Stream_A[1].stop;				 
			 }
			if (operation_counter == 4)
			 {
				 run_time = Speedy_Stream_A[2].run;
				 stop_time = Speedy_Stream_A[2].stop;				 
			 }
			if (operation_counter == 5)
			 {
				 run_time = Speedy_Stream_A[3].run;
				 stop_time = Speedy_Stream_A[3].stop;				
			 }
		}
	   if (program_buff == FASTEST)
	    {
			if (operation_counter == 1)
			 {
				 run_time = Fastest_Stream_A[0].run;
				 stop_time = Fastest_Stream_A[0].stop;				 				 
			 }
			if (operation_counter == 3)	
			 {
				 run_time = Fastest_Stream_A[1].run;
				 stop_time = Fastest_Stream_A[1].stop;				 				 
			 }		
		}
*/
//	   else
	    {
			run_time = Stream_Table_A[stream_table_row][water_level].run;
			stop_time = Stream_Table_A[stream_table_row][water_level].stop; 
		}
   }
   
  if (stream_buff == EXT_STREAM)
   {
	   run_time = Stream_Table_Ext_A[ext_stream_table_row][water_level].run;
	   stop_time = Stream_Table_Ext_A[ext_stream_table_row][water_level].stop;
   }   
   
  if (stream_buff == BALANCE_STREAM)
   {
	   run_time = Balance_Stream_A[0].run;
	   stop_time = Balance_Stream_A[0].stop;
   }   
   
   stream_moto(run_time, stop_time);
   
   return;
   
/*
  if (stream_buff == SOFT_STREAM)
   {
	 ;
   }
  if (stream_buff == RESOLVE_STREAM)
   {
	 ;
   }
*/

}

/***********************************************************************************************

void stream_moto(unsigned int run, unsigned int stop): תд

***********************************************************************************************/

void stream_moto(unsigned int run, unsigned int stop)
{
	unsigned char i;
	unsigned char j;
	
	static signed char stream_run_time_buff;
	static signed char stream_stop_time_buff;
	
if (status_buff != RUN)
return;							/* ״̬ */
 
if (stream_100ms_buff == 0)
 {
	 stream_100ms_buff = 1;		/* ÿ100msһתж */
	 
	 j = stream_buff;
	 j &= 0x01;
	
  if (j != 0)							/* ˮб־Ϊ1ʱת */
   {
	if (stream_start_flag == 0)			/* תʼ */
	 {
		 stream_run_time_buff = run/100;
		 stream_stop_time_buff = stop/100;
		 mot_cycle_buff = MOT_RIGHT;
		 output_buff |= CW;
		 
		 stream_start_flag = 1;
	 }
	
	i = mot_cycle_buff;
	
	switch (mot_cycle_buff)
	 {
		 case MOT_RIGHT: 			/* 缫ת */
		 
		 stream_run_time_buff --;
		 if (stream_run_time_buff == 0)
		  {
			  stream_run_time_buff = run/100;
			  mot_cycle_buff &= MOT_STOP_1;
			  output_buff &= (~CW);
//			  output_buff &= (~CCW);			  
		  }
		  
		 break;
		 
		 
		 case MOT_STOP_1: 			/* 缫ֹͣ */
		 
		 stream_stop_time_buff --;
		 if (stream_stop_time_buff == 0)
		  {
			  stream_stop_time_buff = stop/100;
			  mot_cycle_buff &= MOT_LEFT;
			  output_buff |= CCW;
		  }
		  
		 break;
		 
		 
		 case MOT_LEFT: 			/* 缫ת */
		 
		 stream_run_time_buff --;
		 if (stream_run_time_buff == 0)
		  {
			  stream_run_time_buff = run/100;
			  mot_cycle_buff &= MOT_STOP_2;
//			  output_buff &= (~CW);
			  output_buff &= (~CCW);				  			  
		  }
		  
		 break;
		 
		 
		 case MOT_STOP_2: 			/* 缫ֹͣ */
		 
		 stream_stop_time_buff --;
		 if (stream_stop_time_buff == 0)
		  {
			  stream_stop_time_buff = stop/100;
			  mot_cycle_buff |= MOT_RIGHT;
			  output_buff |= CW;
		  }
	 };
	 
    return;
  
   }

  else if (j == 0)
   {
	 stream_start_flag = 0;
//	 mot_cycle_buff &= MOT_STOP;
//	 return;
   }

 }
else
return;
}


